/****************************************************************************
*  TUTORIAL ONE : NET YAROZE SKELETON CODE                                  *
*    CREATED BY : SCOTT WARD                                                *
*          DATE : 2/5/99                                                    *
*         NOTES : THIS CODE JUST GETS THE NET YAROZE WORKING AT IT'S MOST   *
*                 BASIC LEVEL.IT SHOULD CREATE A SIMPLE LOOP WHICH DISPLAYS *
*                 A BLANK SCREEN.                                           *
*                 THIS CODE IS PRETTY MUCH STANDARD SO DON'T WORRY ABOUT    *
*                 COPYING IT WHEN CREATING SOFTWARE.                        *
****************************************************************************/

/**********INCLUDES**********/

#include <libps.h>

/**********CONSTANTS**********/

#define OT_LENGTH 2

/**********GLOBAL VARIABLES**********/

PACKET packetaddress[2][100];
int currentbuffer;
GsOT OTtable[2];
GsOT_TAG OTtags[2][1<<OT_LENGTH];

/**********MAIN**********/

void main()
{
        //Initialise drawing environment.
        GsInitGraph(320,256,4,0,0);
        GsDefDispBuff(0,0,0,256);
                
        //This initialises the ordering table that is to be used.
        OTtable[0].length=OT_LENGTH;
        OTtable[1].length=OT_LENGTH;
        OTtable[0].org=OTtags[0];
        OTtable[1].org=OTtags[1];

        for(;;)
        {
                //Find out which buffer is being used.
                currentbuffer = GsGetActiveBuff();

                //Tell Yaroze which primitive area to use.
                GsSetWorkBase((PACKET *)packetaddress[currentbuffer]);

                //This clears ordering table, ready to write a new one.
                GsClearOt(0,0,&OTtable[currentbuffer]);

                //These two functions wait for full screen to be drawn
                //before drawing a new one, keeps things smooth.
                DrawSync(0);
                VSync(0);

                //Swaps display buffer so previous display is now being used
                //for drawing and vice versa.
                GsSwapDispBuff();

                //This draws clear screen in display buffer, prevents random
                //stuff appearing as background.
                GsSortClear(255,0,0,&OTtable[currentbuffer]);

                //The graphics processor now draws whatever's in the ordering
                //table.It then loops to draw the next frame.
                GsDrawOt(&OTtable[currentbuffer]);
        }
        
}

/**********END OF MAIN**********/
